<?php
/* summary.class.php - phpgitweb
 * Copyright (C) 2011-2012  Philipp Kreil (pk910)
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program. If not, see <http://www.gnu.org/licenses/>. 
 */

require_once('pages/shortlog.class.php');

class page_summary {
    private $page, $phpgitweb;
	
    public function main($phpgitweb, $project) {
		$this->phpgitweb = $phpgitweb;
		if(!$project)
			return new ContentProvider('main', 'err400');
		$project['refs'] = $phpgitweb->get_project_loader()->getProjectRefs($project);
		$phpgitweb->append_header_nav("summary", null, true);
		$phpgitweb->append_title("summary");
		CommitLoader::parse(true);
		
		$this->page = new ContentProvider('summary', 'main');
		
		$this->page->set('description', htmlentities($project['description']));
		$this->page->set('owner', htmlentities($project['owner']));
		
		$giturls = GitConfig::$GIT_BASE_URL;
		$urlfield = "";
		foreach($giturls as $url) {
			if($urlfield != "")
				$urlfield .= "<br \>";
			$urlfield .= $url.(substr($url, -1) == '/' ? '' : '/').$project['name'];
		}
		if($urlfield != "")
			$this->page->set('giturl', new ContentProvider('summary', 'giturl', array('git_link' => $urlfield)));
		else
			$this->page->set('giturl', '');
		
		$shortlog = new shortlog();
		$this->page->set('shortlog', $shortlog->generate_shortlog($project, null, 16, 0, null, false));
		$first_commit = $shortlog->get_first_commit();
		
		$this->page->set('last_change', gmdate('r', $first_commit['committer_time']));
		
		return $this->page;
	}
	
}

?>